## ros-class-loader 0.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(class_loader)

find_package(Boost REQUIRED COMPONENTS thread system)
find_package(catkin QUIET)
find_package(console_bridge REQUIRED)

if(${catkin_FOUND})
  find_package(catkin REQUIRED COMPONENTS cmake_modules)
  find_package(Poco REQUIRED COMPONENTS Foundation)
  catkin_package(
    INCLUDE_DIRS include
    LIBRARIES ${PROJECT_NAME} ${Poco_LIBRARIES}
    DEPENDS Boost Poco console_bridge
    CFG_EXTRAS class_loader-extras.cmake
  )
else()
  message("-- catkin not found")
  set(Poco_DIR cmake)
  find_package(Poco REQUIRED COMPONENTS Foundation)
  set(CATKIN_PACKAGE_LIB_DESTINATION lib)
  set(CATKIN_GLOBAL_BIN_DESTINATION bin)
  set(CATKIN_GLOBAL_BIN_DESTINATION bin)
  set(CATKIN_PACKAGE_INCLUDE_DESTINATION include/class_loader)
endif()

include_directories(include ${console_bridge_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})

set(${PROJECT_NAME}_SRCS
  src/class_loader.cpp
  src/class_loader_core.cpp
  src/meta_object.cpp
  src/multi_library_class_loader.cpp
)
add_library(${PROJECT_NAME} ${${PROJECT_NAME}_SRCS})
target_link_libraries(${PROJECT_NAME} ${Boost_LIBRARIES} ${console_bridge_LIBRARIES} ${Poco_LIBRARIES})

install(TARGETS ${PROJECT_NAME}
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})
install(DIRECTORY include/class_loader/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})

if(CATKIN_ENABLE_TESTING)
  add_subdirectory(test)
endif()

if(NOT ${catkin_FOUND})
  set(TARGET_NAME ${PROJECT_NAME})
  set(PKGCONFIG_LIBS 
    ${Boost_LIBRARIES} 
    ${console_bridge_LIBRARIES} 
    ${Poco_LIBRARIES}
  )

  # Prepare and install necessary files to support finding of the library 
  # using pkg-config
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/${TARGET_NAME}.pc.in
                 ${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME}.pc @ONLY)

  install(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc DESTINATION lib/pkgconfig)
endif()

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

find_package(Boost REQUIRED COMPONENTS thread)
find_package(catkin REQUIRED COMPONENTS class_loader)

include_directories(${catkin_INCLUDE_DIRS})

add_library(${PROJECT_NAME}_TestPlugins1 EXCLUDE_FROM_ALL plugins1.cpp)
target_link_libraries(${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins1)
add_library(${PROJECT_NAME}_TestPlugins2 EXCLUDE_FROM_ALL plugins2.cpp)
target_link_libraries(${PROJECT_NAME}_TestPlugins2 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins2)

catkin_add_gtest(${PROJECT_NAME}_utest utest.cpp)
if(TARGET ${PROJECT_NAME}_utest)
  target_link_libraries(${PROJECT_NAME}_utest ${Boost_LIBRARIES} ${class_loader_LIBRARIES})
  add_dependencies(${PROJECT_NAME}_utest ${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME}_TestPlugins2)
endif()

=== debian/changelog ===
ros-class-loader (0.3.2-1) unstable; urgency=medium

  * Initial release (Closes: #804932)

 -- Jochen Sprickerhof <debian@jochen.sprickerhof.de>  Fri, 25 Dec 2015 21:17:00 +0000

=== debian/control ===
Source: ros-class-loader
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Thomas Moulard <thomas.moulard@gmail.com>,
           Jochen Sprickerhof <debian@jochen.sprickerhof.de>,
           Leopold Palomo-Avellaneda <leo@alaxarxa.net>
Build-Depends: debhelper (>= 9), catkin (>> 0.6.16-2), libboost-thread-dev, libboost-system-dev,
		libconsole-bridge-dev, libpoco-dev, ros-cmake-modules
Standards-Version: 3.9.6
Section: libs
Homepage: http://wiki.ros.org/class_loader
Vcs-Git: git://anonscm.debian.org/debian-science/packages/ros/ros-class-loader.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/ros/ros-class-loader.git

Package: libclass-loader-dev
Section: libdevel
Architecture: any
Depends: libclass-loader0d (= ${binary:Version}), libpoco-dev, libconsole-bridge-dev, libboost-dev, libboost-thread-dev, libboost-system-dev, ${misc:Depends}
Description: development files for Robot OS class_loader library
 This package is part of Robot OS (ROS). The class_loader package is a
 ROS-independent package for loading plugins during runtime and the
 foundation of the higher level ROS "pluginlib" library.  class_loader
 utilizes the host operating system's runtime loader to open runtime
 libraries (e.g. .so/.dll files), introspect the library for exported
 plugin classes, and allows users to instantiate objects of said
 exported classes without the explicit declaration (i.e. header file)
 for those classes.
 .
 This package contains the development files for the library.

Package: libclass-loader0d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: ROS class_loader library
 This package is part of Robot OS (ROS). The class_loader package is a
 ROS-independent package for loading plugins during runtime and the
 foundation of the higher level ROS "pluginlib" library.  class_loader
 utilizes the host operating system's runtime loader to open runtime
 libraries (e.g. .so/.dll files), introspect the library for exported
 plugin classes, and allows users to instantiate objects of said
 exported classes without the explicit declaration (i.e. header file)
 for those classes. 
 .
 This package contains the library.

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ 

# test suite is broken atm.
override_dh_auto_test:

get-orig-source:
	uscan --verbose --force-download --repack --compress xz

=== debian/watch ===
# Watch control file for uscan
# Compulsory line, this is a version 3 file
version=3
# For GitHub projects you can use the tags page:

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/class_loader-$1\.tar\.gz/ \
  https://github.com/ros/class_loader/releases .*/v?(\d\S*)\.tar\.gz

## ros-class-loader 0.3.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,12 @@
 project(class_loader)
 
 find_package(Boost REQUIRED COMPONENTS thread system)
-find_package(catkin QUIET)
+
+set(CATKIN_DISABLED false CACHE BOOL "Disable the catkin build, useful if catkin is present but a build outside or ros is done" )
+if(NOT CATKIN_DISABLED)
+  find_package(catkin QUIET)
+endif()
+
 find_package(console_bridge REQUIRED)
 
 if(${catkin_FOUND})
@@ -32,7 +37,15 @@
   src/meta_object.cpp
   src/multi_library_class_loader.cpp
 )
-add_library(${PROJECT_NAME} ${${PROJECT_NAME}_SRCS})
+set(${PROJECT_NAME}_HDRS
+  include/class_loader/class_loader_core.h
+  include/class_loader/class_loader_exceptions.h
+  include/class_loader/class_loader.h
+  include/class_loader/class_loader_register_macro.h
+  include/class_loader/meta_object.h
+  include/class_loader/multi_library_class_loader.h
+)
+add_library(${PROJECT_NAME} ${${PROJECT_NAME}_SRCS} ${${PROJECT_NAME}_HDRS})
 target_link_libraries(${PROJECT_NAME} ${Boost_LIBRARIES} ${console_bridge_LIBRARIES} ${Poco_LIBRARIES})
 
 install(TARGETS ${PROJECT_NAME}
@@ -46,7 +59,7 @@
   add_subdirectory(test)
 endif()
 
-if(NOT ${catkin_FOUND})
+if(NOT catkin_FOUND)
   set(TARGET_NAME ${PROJECT_NAME})
   set(PKGCONFIG_LIBS 
     ${Boost_LIBRARIES}

=== debian/changelog ===
ros-class-loader (0.3.4-1build1) yakkety; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 04 Aug 2016 08:31:41 +0000

ros-class-loader (0.3.4-1) unstable; urgency=medium

  * Imported Upstream version 0.3.4
  * Refresh patches

 -- Jochen Sprickerhof <debian@jochen.sprickerhof.de>  Sun, 10 Jul 2016 12:27:06 +0200

## ros-class-loader 0.3.6

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -17,3 +17,14 @@
   target_link_libraries(${PROJECT_NAME}_utest ${Boost_LIBRARIES} ${class_loader_LIBRARIES})
   add_dependencies(${PROJECT_NAME}_utest ${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME}_TestPlugins2)
 endif()
+
+include(CheckCXXCompilerFlag)
+CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
+if(COMPILER_SUPPORTS_CXX11)
+  catkin_add_gtest(${PROJECT_NAME}_unique_ptr_test unique_ptr_test.cpp)
+  if(TARGET ${PROJECT_NAME}_unique_ptr_test)
+    target_link_libraries(${PROJECT_NAME}_unique_ptr_test ${Boost_LIBRARIES} ${class_loader_LIBRARIES})
+	set_target_properties(${PROJECT_NAME}_unique_ptr_test PROPERTIES COMPILE_FLAGS -std=c++11 LINK_FLAGS -std=c++11)
+    add_dependencies(${PROJECT_NAME}_unique_ptr_test ${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME}_TestPlugins2)
+  endif()
+endif()

=== debian/changelog ===
ros-class-loader (0.3.6-1build2) artful; urgency=medium

  * No-change rebuild against libpocofoundation48

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 26 Aug 2017 08:19:29 +0000

ros-class-loader (0.3.6-1build1) zesty; urgency=medium

  * Rebuild against new libpoco*46.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 16 Nov 2016 09:30:27 +0100

ros-class-loader (0.3.6-1) unstable; urgency=medium

  * New upstream version 0.3.6

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 04 Nov 2016 09:49:23 +0100

ros-class-loader (0.3.5-1) unstable; urgency=medium

  * Bumped Standards-Version to 3.9.8, no changes needed.
  * Update Vcs URLs
  * Update my email address
  * New upstream version 0.3.5

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 24 Sep 2016 17:55:01 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: ros-class-loader
 Priority: optional
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Thomas Moulard <thomas.moulard@gmail.com>,
-           Jochen Sprickerhof <debian@jochen.sprickerhof.de>,
+           Jochen Sprickerhof <jspricke@debian.org>,
            Leopold Palomo-Avellaneda <leo@alaxarxa.net>
 Build-Depends: debhelper (>= 9), catkin (>> 0.6.16-2), libboost-thread-dev, libboost-system-dev,
 		libconsole-bridge-dev, libpoco-dev, ros-cmake-modules
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Section: libs
 Homepage: http://wiki.ros.org/class_loader
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/ros/ros-class-loader.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/ros/ros-class-loader.git
+Vcs-Git: https://anonscm.debian.org/cgit/debian-science/packages/ros/ros-class-loader.git
+Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ros/ros-class-loader.git
 
 Package: libclass-loader-dev
 Section: libdevel

## ros-class-loader 0.3.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 
 find_package(Boost REQUIRED COMPONENTS thread system)
 
-set(CATKIN_DISABLED false CACHE BOOL "Disable the catkin build, useful if catkin is present but a build outside or ros is done" )
+set(CATKIN_DISABLED false CACHE BOOL "Disable the catkin build, useful if catkin is present but a build outside of ros is done")
 if(NOT CATKIN_DISABLED)
   find_package(catkin QUIET)
 endif()
@@ -38,10 +38,11 @@
   src/multi_library_class_loader.cpp
 )
 set(${PROJECT_NAME}_HDRS
+  include/class_loader/class_loader.h
   include/class_loader/class_loader_core.h
   include/class_loader/class_loader_exceptions.h
-  include/class_loader/class_loader.h
   include/class_loader/class_loader_register_macro.h
+  include/class_loader/console_bridge_compatibility.h
   include/class_loader/meta_object.h
   include/class_loader/multi_library_class_loader.h
 )
@@ -61,16 +62,16 @@
 
 if(NOT catkin_FOUND)
   set(TARGET_NAME ${PROJECT_NAME})
-  set(PKGCONFIG_LIBS 
-    ${Boost_LIBRARIES} 
-    ${console_bridge_LIBRARIES} 
+  set(PKGCONFIG_LIBS
+    ${Boost_LIBRARIES}
+    ${console_bridge_LIBRARIES}
     ${Poco_LIBRARIES}
   )
 
-  # Prepare and install necessary files to support finding of the library 
+  # Prepare and install necessary files to support finding of the library
   # using pkg-config
   configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/${TARGET_NAME}.pc.in
-                 ${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME}.pc @ONLY)
+    ${CMAKE_CURRENT_BINARY_DIR}/${TARGET_NAME}.pc @ONLY)
 
   install(FILES ${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc DESTINATION lib/pkgconfig)
 endif()

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -19,12 +19,12 @@
 endif()
 
 include(CheckCXXCompilerFlag)
-CHECK_CXX_COMPILER_FLAG("-std=c++11" COMPILER_SUPPORTS_CXX11)
+check_cxx_compiler_flag("-std=c++11" COMPILER_SUPPORTS_CXX11)
 if(COMPILER_SUPPORTS_CXX11)
   catkin_add_gtest(${PROJECT_NAME}_unique_ptr_test unique_ptr_test.cpp)
   if(TARGET ${PROJECT_NAME}_unique_ptr_test)
     target_link_libraries(${PROJECT_NAME}_unique_ptr_test ${Boost_LIBRARIES} ${class_loader_LIBRARIES})
-	set_target_properties(${PROJECT_NAME}_unique_ptr_test PROPERTIES COMPILE_FLAGS -std=c++11 LINK_FLAGS -std=c++11)
+    set_target_properties(${PROJECT_NAME}_unique_ptr_test PROPERTIES COMPILE_FLAGS -std=c++11 LINK_FLAGS -std=c++11)
     add_dependencies(${PROJECT_NAME}_unique_ptr_test ${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME}_TestPlugins2)
   endif()
 endif()

=== debian/changelog ===
ros-class-loader (0.3.8-1build2) bionic; urgency=medium

  * No-change rebuild against libconsole-bridge0.4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 02 Mar 2018 07:12:14 +0000

ros-class-loader (0.3.8-1build1) bionic; urgency=medium

  * No-change rebuild for libpoco soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 10 Feb 2018 00:14:47 +0000

ros-class-loader (0.3.8-1) unstable; urgency=medium

  * Update watch file
  * Remove old catkin version
  * Limit watch file to ROS1 version
  * New upstream version 0.3.8
  * Update policy and debhelper versions

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 23 Dec 2017 17:34:22 +0100

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Uploaders: Thomas Moulard <thomas.moulard@gmail.com>,
            Jochen Sprickerhof <jspricke@debian.org>,
            Leopold Palomo-Avellaneda <leo@alaxarxa.net>
-Build-Depends: debhelper (>= 9), catkin (>> 0.6.16-2), libboost-thread-dev, libboost-system-dev,
+Build-Depends: debhelper (>= 10), catkin, libboost-thread-dev, libboost-system-dev,
 		libconsole-bridge-dev, libpoco-dev, ros-cmake-modules
-Standards-Version: 3.9.8
+Standards-Version: 4.1.2
 Section: libs
 Homepage: http://wiki.ros.org/class_loader
 Vcs-Git: https://anonscm.debian.org/cgit/debian-science/packages/ros/ros-class-loader.git

## ros-class-loader 0.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,13 @@
-cmake_minimum_required(VERSION 2.8.3)
-project(class_loader)
+cmake_minimum_required(VERSION 3.5)
+project(class_loader CXX)
+
+# Default to C++14
+if(NOT CMAKE_CXX_STANDARD)
+  set(CMAKE_CXX_STANDARD 14)
+endif()
+if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
+  add_compile_options(-Wall -Wextra -Wpedantic)
+endif()
 
 find_package(Boost REQUIRED COMPONENTS thread system)
 
@@ -38,16 +46,20 @@
   src/multi_library_class_loader.cpp
 )
 set(${PROJECT_NAME}_HDRS
-  include/class_loader/class_loader.h
-  include/class_loader/class_loader_core.h
-  include/class_loader/class_loader_exceptions.h
-  include/class_loader/class_loader_register_macro.h
-  include/class_loader/console_bridge_compatibility.h
-  include/class_loader/meta_object.h
-  include/class_loader/multi_library_class_loader.h
+  include/class_loader/class_loader.hpp
+  include/class_loader/class_loader_core.hpp
+  include/class_loader/exceptions.hpp
+  include/class_loader/meta_object.hpp
+  include/class_loader/multi_library_class_loader.hpp
+  include/class_loader/register_macro.hpp
 )
 add_library(${PROJECT_NAME} ${${PROJECT_NAME}_SRCS} ${${PROJECT_NAME}_HDRS})
 target_link_libraries(${PROJECT_NAME} ${Boost_LIBRARIES} ${console_bridge_LIBRARIES} ${Poco_LIBRARIES})
+if(WIN32)
+  # Causes the visibility macros to use dllexport rather than dllimport
+  # which is appropriate when building the dll but not consuming it.
+  target_compile_definitions(${PROJECT_NAME} PRIVATE "CLASS_LOADER_BUILDING_DLL")
+endif()
 
 install(TARGETS ${PROJECT_NAME}
   ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
@@ -55,6 +67,9 @@
   RUNTIME DESTINATION ${CATKIN_GLOBAL_BIN_DESTINATION})
 install(DIRECTORY include/class_loader/
   DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION})
+
+install(PROGRAMS scripts/class_loader_headers_update.py
+  DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})
 
 if(CATKIN_ENABLE_TESTING)
   add_subdirectory(test)

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

find_package(Boost REQUIRED COMPONENTS thread)
find_package(catkin REQUIRED COMPONENTS class_loader)

include_directories(${catkin_INCLUDE_DIRS})

add_library(${PROJECT_NAME}_TestPlugins1 EXCLUDE_FROM_ALL plugins1.cpp)
target_link_libraries(${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins1)
add_library(${PROJECT_NAME}_TestPlugins2 EXCLUDE_FROM_ALL plugins2.cpp)
target_link_libraries(${PROJECT_NAME}_TestPlugins2 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins2)

catkin_add_gtest(${PROJECT_NAME}_utest utest.cpp)
if(TARGET ${PROJECT_NAME}_utest)
  target_link_libraries(${PROJECT_NAME}_utest ${Boost_LIBRARIES} ${class_loader_LIBRARIES})
  add_dependencies(${PROJECT_NAME}_utest ${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME}_TestPlugins2)
endif()

catkin_add_gtest(${PROJECT_NAME}_shared_ptr_test shared_ptr_test.cpp)
if(TARGET ${PROJECT_NAME}_shared_ptr_test)
  target_link_libraries(${PROJECT_NAME}_shared_ptr_test ${Boost_LIBRARIES} ${class_loader_LIBRARIES})
  add_dependencies(${PROJECT_NAME}_shared_ptr_test ${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME}_TestPlugins2)
endif()

catkin_add_gtest(${PROJECT_NAME}_unique_ptr_test unique_ptr_test.cpp)
if(TARGET ${PROJECT_NAME}_unique_ptr_test)
  target_link_libraries(${PROJECT_NAME}_unique_ptr_test ${Boost_LIBRARIES} ${class_loader_LIBRARIES})
  add_dependencies(${PROJECT_NAME}_unique_ptr_test ${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME}_TestPlugins2)
endif()

=== debian/changelog ===
ros-class-loader (0.4.1-2build3) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 21:32:15 +0000

ros-class-loader (0.4.1-2build2) eoan; urgency=medium

  * No change rebuild to pick up poco multiarch locations

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 21 Aug 2019 16:21:09 +0200

ros-class-loader (0.4.1-2build1) cosmic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Jul 2018 13:13:33 +0000

ros-class-loader (0.4.1-2) unstable; urgency=medium

  * Upload to unstable

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 21 Jun 2018 09:00:53 +0200

ros-class-loader (0.4.1-1) experimental; urgency=medium

  * Update Vcs URLs to salsa.d.o
  * Add R³
  * http -> https
  * New upstream version 0.4.1
  * Update copyright
  * Rebase patch
  * Bump Soname due to ABI change
  * Bump policy version

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 16 Jun 2018 19:09:15 +0200

=== debian/control ===
--- 
+++ 
@@ -5,18 +5,19 @@
 Uploaders: Thomas Moulard <thomas.moulard@gmail.com>,
            Jochen Sprickerhof <jspricke@debian.org>,
            Leopold Palomo-Avellaneda <leo@alaxarxa.net>
-Build-Depends: debhelper (>= 10), catkin, libboost-thread-dev, libboost-system-dev,
+Build-Depends: debhelper (>= 11), catkin, libboost-thread-dev, libboost-system-dev,
 		libconsole-bridge-dev, libpoco-dev, ros-cmake-modules
-Standards-Version: 4.1.2
+Standards-Version: 4.1.4
 Section: libs
-Homepage: http://wiki.ros.org/class_loader
-Vcs-Git: https://anonscm.debian.org/cgit/debian-science/packages/ros/ros-class-loader.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-science/packages/ros/ros-class-loader.git
+Rules-Requires-Root: no
+Homepage: https://wiki.ros.org/class_loader
+Vcs-Git: https://salsa.debian.org/science-team/ros-class-loader.git
+Vcs-Browser: https://salsa.debian.org/science-team/ros-class-loader
 
 Package: libclass-loader-dev
 Section: libdevel
 Architecture: any
-Depends: libclass-loader0d (= ${binary:Version}), libpoco-dev, libconsole-bridge-dev, libboost-dev, libboost-thread-dev, libboost-system-dev, ${misc:Depends}
+Depends: libclass-loader1d (= ${binary:Version}), libpoco-dev, libconsole-bridge-dev, libboost-dev, libboost-thread-dev, libboost-system-dev, ${misc:Depends}
 Description: development files for Robot OS class_loader library
  This package is part of Robot OS (ROS). The class_loader package is a
  ROS-independent package for loading plugins during runtime and the
@@ -29,7 +30,7 @@
  .
  This package contains the development files for the library.
 
-Package: libclass-loader0d
+Package: libclass-loader1d
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ 

# test suite is broken atm.
override_dh_auto_test:

## ros-class-loader 0.5.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -31,10 +31,13 @@
   message("-- catkin not found")
   set(Poco_DIR cmake)
   find_package(Poco REQUIRED COMPONENTS Foundation)
-  set(CATKIN_PACKAGE_LIB_DESTINATION lib)
   set(CATKIN_GLOBAL_BIN_DESTINATION bin)
-  set(CATKIN_GLOBAL_BIN_DESTINATION bin)
-  set(CATKIN_PACKAGE_INCLUDE_DESTINATION include/class_loader)
+  set(CATKIN_GLOBAL_LIB_DESTINATION lib)
+  set(CATKIN_GLOBAL_LIBEXEC_DESTINATION lib)
+  set(CATKIN_GLOBAL_INCLUDE_DESTINATION include)
+  set(CATKIN_PACKAGE_LIB_DESTINATION ${CATKIN_GLOBAL_LIB_DESTINATION})
+  set(CATKIN_PACKAGE_BIN_DESTINATION ${CATKIN_GLOBAL_LIBEXEC_DESTINATION}/${PROJECT_NAME})
+  set(CATKIN_PACKAGE_INCLUDE_DESTINATION ${CATKIN_GLOBAL_INCLUDE_DESTINATION}/${PROJECT_NAME})
 endif()
 
 include_directories(include ${console_bridge_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS} ${Poco_INCLUDE_DIRS})
@@ -53,7 +56,12 @@
   include/class_loader/multi_library_class_loader.hpp
   include/class_loader/register_macro.hpp
 )
-add_library(${PROJECT_NAME} ${${PROJECT_NAME}_SRCS} ${${PROJECT_NAME}_HDRS})
+if(WIN32)
+  add_library(${PROJECT_NAME} SHARED ${${PROJECT_NAME}_SRCS} ${${PROJECT_NAME}_HDRS})
+else()
+  add_library(${PROJECT_NAME} ${${PROJECT_NAME}_SRCS} ${${PROJECT_NAME}_HDRS})
+endif()
+
 target_link_libraries(${PROJECT_NAME} ${Boost_LIBRARIES} ${console_bridge_LIBRARIES} ${Poco_LIBRARIES})
 if(WIN32)
   # Causes the visibility macros to use dllexport rather than dllimport

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -7,9 +7,21 @@
 
 add_library(${PROJECT_NAME}_TestPlugins1 EXCLUDE_FROM_ALL plugins1.cpp)
 target_link_libraries(${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME})
+if(WIN32)
+  # On Windows, default library runtime output set to CATKIN_GLOBAL_BIN_DESTINATION,
+  # change it back to CATKIN_PACKAGE_BIN_DESTINATION so the test can run correctly
+  set_target_properties(${PROJECT_NAME}_TestPlugins1 PROPERTIES 
+    RUNTIME_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION})
+endif()
 class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins1)
 add_library(${PROJECT_NAME}_TestPlugins2 EXCLUDE_FROM_ALL plugins2.cpp)
 target_link_libraries(${PROJECT_NAME}_TestPlugins2 ${PROJECT_NAME})
+if(WIN32)
+  # On Windows, default library runtime output set to CATKIN_GLOBAL_BIN_DESTINATION,
+  # change it back to CATKIN_PACKAGE_BIN_DESTINATION so the test can run correctly
+  set_target_properties(${PROJECT_NAME}_TestPlugins2 PROPERTIES 
+    RUNTIME_OUTPUT_DIRECTORY ${CATKIN_DEVEL_PREFIX}/${CATKIN_PACKAGE_BIN_DESTINATION})
+endif()
 class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins2)
 
 catkin_add_gtest(${PROJECT_NAME}_utest utest.cpp)

=== debian/changelog ===
ros-class-loader (0.5.0-5build1) jammy; urgency=medium

  * No-change rebuild against libconsole-bridge1.0

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 07 Nov 2021 17:30:44 +0000

ros-class-loader (0.5.0-5) unstable; urgency=medium

  * Team upload.
  * Upload to unstable
  * Fix Multiarch hinter issues

 -- Timo Röhling <roehling@debian.org>  Wed, 22 Sep 2021 22:41:45 +0200

ros-class-loader (0.5.0-4) experimental; urgency=medium

  * Team upload.
  * Move pkg-config and CMake config files to /usr/lib/<triplet>
  * Bump Standards-Version to 4.6.0 (no changes)

 -- Timo Röhling <roehling@debian.org>  Fri, 03 Sep 2021 17:50:50 +0200

ros-class-loader (0.5.0-3) unstable; urgency=medium

  * simplify packaging

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 19 Dec 2020 11:55:04 +0100

ros-class-loader (0.5.0-2) unstable; urgency=medium

  * Add patch for Boost 1.74
  * bump policy version (no changes)

 -- Jochen Sprickerhof <jspricke@debian.org>  Mon, 14 Dec 2020 11:40:51 +0100

ros-class-loader (0.5.0-1) unstable; urgency=medium

  * add Salsa CI
  * simplify d/watch
  * New upstream version 0.5.0
  * Update dependencies
  * rebase patches
  * Remove Thomas from Uploaders, thanks for working on this
  * bump policy and debhelper versions

 -- Jochen Sprickerhof <jspricke@debian.org>  Sat, 06 Jun 2020 11:29:06 +0200

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,11 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Thomas Moulard <thomas.moulard@gmail.com>,
-           Jochen Sprickerhof <jspricke@debian.org>,
+Uploaders: Jochen Sprickerhof <jspricke@debian.org>,
            Leopold Palomo-Avellaneda <leo@alaxarxa.net>
-Build-Depends: debhelper (>= 11), catkin, libboost-thread-dev, libboost-system-dev,
+Build-Depends: debhelper-compat (= 13), catkin (>= 0.8.10-1~), libboost-thread-dev, libboost-system-dev,
 		libconsole-bridge-dev, libpoco-dev, ros-cmake-modules
-Standards-Version: 4.1.4
+Standards-Version: 4.6.0
 Section: libs
 Rules-Requires-Root: no
 Homepage: https://wiki.ros.org/class_loader
@@ -17,7 +16,8 @@
 Package: libclass-loader-dev
 Section: libdevel
 Architecture: any
-Depends: libclass-loader1d (= ${binary:Version}), libpoco-dev, libconsole-bridge-dev, libboost-dev, libboost-thread-dev, libboost-system-dev, ${misc:Depends}
+Multi-Arch: same
+Depends: libclass-loader1d (= ${binary:Version}), libpoco-dev, libconsole-bridge-dev, libboost-thread-dev, libboost-system-dev, ${misc:Depends}
 Description: development files for Robot OS class_loader library
  This package is part of Robot OS (ROS). The class_loader package is a
  ROS-independent package for loading plugins during runtime and the

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ros-class-loader-$1.tar.gz%" \
    https://github.com/ros/class_loader/tags \
    (?:.*?/)?v?(0.\d[\d.]*)\.tar\.gz

## ros-class-loader 2.3.0

=== debian/changelog ===
ros-class-loader (2.3.0-7) unstable; urgency=medium

  * Add breaks for autopkgtests

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 14 Jun 2022 19:32:12 +0200

ros-class-loader (2.3.0-6) unstable; urgency=medium

  * Fix patch for HPPA

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 12 Jun 2022 17:30:29 +0200

ros-class-loader (2.3.0-5) unstable; urgency=medium

  * Fix test for powerpc

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 12 Jun 2022 16:33:12 +0200

ros-class-loader (2.3.0-4) unstable; urgency=medium

  * Disable an other test

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 12 Jun 2022 15:08:30 +0200

ros-class-loader (2.3.0-3) unstable; urgency=medium

  * Add patch for failing tests

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 12 Jun 2022 13:53:19 +0200

ros-class-loader (2.3.0-2) unstable; urgency=medium

  * Upload to unstable

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 12 Jun 2022 10:58:18 +0200

ros-class-loader (2.3.0-1) experimental; urgency=medium

  * d/watch allow latest upstream again
  * New upstream version 2.3.0
  * Update d/copyright
  * Switch to ament and dh-ros
  * Bump Soname due to ABI change
  * Bump policy version (no changes)

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 02 Jun 2022 21:57:45 +0200

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,19 @@
 Source: ros-class-loader
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jochen Sprickerhof <jspricke@debian.org>,
            Leopold Palomo-Avellaneda <leo@alaxarxa.net>
-Build-Depends: debhelper-compat (= 13), catkin (>= 0.8.10-1~), libboost-thread-dev, libboost-system-dev,
-		libconsole-bridge-dev, libpoco-dev, ros-cmake-modules
-Standards-Version: 4.6.0
+Build-Depends:
+ debhelper-compat (= 13),
+ ament-cmake,
+ ament-cmake-googletest <!nocheck>,
+ ament-cmake-ros,
+ ament-lint <!nocheck>,
+ cmake,
+ dh-ros,
+ libconsole-bridge-dev,
+ librcpputils-dev,
+Standards-Version: 4.6.1
 Section: libs
 Rules-Requires-Root: no
 Homepage: https://wiki.ros.org/class_loader
@@ -17,7 +24,12 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libclass-loader1d (= ${binary:Version}), libpoco-dev, libconsole-bridge-dev, libboost-thread-dev, libboost-system-dev, ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ libclass-loader2d (= ${binary:Version}),
+ libconsole-bridge-dev,
+ librcpputils-dev,
+Breaks: pluginlib-dev (<< 5.2.0)
 Description: development files for Robot OS class_loader library
  This package is part of Robot OS (ROS). The class_loader package is a
  ROS-independent package for loading plugins during runtime and the
@@ -30,7 +42,7 @@
  .
  This package contains the development files for the library.
 
-Package: libclass-loader1d
+Package: libclass-loader2d
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f

export ROS_CONFIGURE_ARGS = -DCLASS_LOADER_SOVERSION=2d
export ROS_EXECUTE_AFTER_CONFIGURE=sed -i -e '1icmake_policy(SET CMP0057 NEW)' -e '$$aset(class_loader_FOUND_CATKIN_PROJECT TRUE)\nset(class_loader_INCLUDE_DIRS "/usr/include/class_loader;/usr/include/rcpputils;/usr/include/rcutils")\nset(class_loader_LIBRARIES "class_loader")' obj-$(DEB_HOST_GNU_TYPE)/class_loader/ament_cmake_core/class_loaderConfig.cmake

%:
	dh $@ --buildsystem=ros

## ros-class-loader 2.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(class_loader)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

set(CLASS_LOADER_IGNORE_AMENT FALSE CACHE BOOL
  "Do not use ament when building this package.")
if(NOT CLASS_LOADER_IGNORE_AMENT)
  find_package(ament_cmake)
  find_package(ament_cmake_ros REQUIRED)
  set(explicit_library_type "")
else()
  set(explicit_library_type "SHARED")
endif()

find_package(console_bridge_vendor REQUIRED) # Provides console_bridge 0.4.0 on platforms without it.
find_package(console_bridge REQUIRED)

find_package(rcpputils REQUIRED)

if(ament_cmake_FOUND)
  ament_export_dependencies(console_bridge)
  ament_export_dependencies(rcpputils)
endif()

set(${PROJECT_NAME}_SRCS
  src/class_loader.cpp
  src/class_loader_core.cpp
  src/meta_object.cpp
  src/multi_library_class_loader.cpp
)
add_library(${PROJECT_NAME} ${explicit_library_type} ${${PROJECT_NAME}_SRCS})
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")

if(ament_cmake_FOUND)
  target_link_libraries(${PROJECT_NAME}
    console_bridge::console_bridge
    rcpputils::rcpputils)
  ament_export_targets(${PROJECT_NAME})
else()
  target_include_directories(${PROJECT_NAME}
    PUBLIC ${console_bridge_INCLUDE_DIRS})
  target_link_libraries(${PROJECT_NAME} ${console_bridge_LIBRARIES})
endif()
if(WIN32)
  # Causes the visibility macros to use dllexport rather than dllimport
  # which is appropriate when building the dll but not consuming it.
  target_compile_definitions(${PROJECT_NAME} PRIVATE "CLASS_LOADER_BUILDING_DLL")
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto QUIET)
  if(ament_lint_auto_FOUND)
    # TODO(mikaelarguedas) add copyright test once the linter accepts /** block comments
    list(APPEND AMENT_LINT_AUTO_EXCLUDE
      ament_cmake_copyright
    )
    ament_lint_auto_find_test_dependencies()

    # Files in test/fviz_case_study do have compatible copyrights
    find_package(ament_cmake_copyright)
    ament_copyright(
      TESTNAME copyright_check_tests_only
      "test/fviz_case_study"
    )
  endif()
  add_subdirectory(test)
endif()

if(ament_cmake_FOUND)
  ament_package(
    CONFIG_EXTRAS "class_loader-extras.cmake"
  )
else()
  set(TARGET_NAME ${PROJECT_NAME})
  set(PKGCONFIG_LIBS
    ${console_bridge_LIBRARIES}
  )

  # Prepare and install necessary files to support finding of the library
  # using pkg-config
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/src/${PROJECT_NAME}.pc.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
    @ONLY)

  install(FILES "${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc" DESTINATION lib/pkgconfig)
endif()

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin)

install(DIRECTORY cmake
  DESTINATION share/${PROJECT_NAME})

install(DIRECTORY include/ DESTINATION include/${PROJECT_NAME})

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)

include("../cmake/class_loader_hide_library_symbols.cmake")

add_library(${PROJECT_NAME}_TestPlugins1 EXCLUDE_FROM_ALL SHARED plugins1.cpp)
if(ament_cmake_FOUND)
  target_include_directories(${PROJECT_NAME}_TestPlugins1
    PUBLIC "../include")
  ament_target_dependencies(${PROJECT_NAME}_TestPlugins1 "console_bridge")
else()
  target_include_directories(${PROJECT_NAME}_TestPlugins1
    PUBLIC "../include" ${console_bridge_INCLUDE_DIRS})
endif()
target_link_libraries(${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins1)

add_library(${PROJECT_NAME}_TestPlugins2 EXCLUDE_FROM_ALL SHARED plugins2.cpp)
if(ament_cmake_FOUND)
  target_include_directories(${PROJECT_NAME}_TestPlugins2
    PUBLIC "../include")
  ament_target_dependencies(${PROJECT_NAME}_TestPlugins2 "console_bridge")
else()
  target_include_directories(${PROJECT_NAME}_TestPlugins2
    PUBLIC "../include" ${console_bridge_INCLUDE_DIRS})
endif()
target_link_libraries(${PROJECT_NAME}_TestPlugins2 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins2)

# These plugins are loaded using dlopen() with RTLD_GLOBAL in utest and may cause side effects
# in other tests if they are used elsewhere.
add_library(${PROJECT_NAME}_TestGlobalPlugins EXCLUDE_FROM_ALL SHARED global_plugins.cpp)
if(ament_cmake_FOUND)
  target_include_directories(${PROJECT_NAME}_TestGlobalPlugins
    PUBLIC "../include")
  ament_target_dependencies(${PROJECT_NAME}_TestGlobalPlugins "console_bridge")
else()
  target_include_directories(${PROJECT_NAME}_TestGlobalPlugins
    PUBLIC "../include" ${console_bridge_INCLUDE_DIRS})
endif()
target_link_libraries(${PROJECT_NAME}_TestGlobalPlugins ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestGlobalPlugins)

if(WIN32)
  set(append_library_dirs "$<TARGET_FILE_DIR:${PROJECT_NAME}>;$<TARGET_FILE_DIR:${PROJECT_NAME}_TestPlugins1>")
else()
  set(append_library_dirs "${CMAKE_CURRENT_BINARY_DIR}")
endif()

ament_add_gtest(${PROJECT_NAME}_utest utest.cpp
  APPEND_LIBRARY_DIRS "${append_library_dirs}"
)

if(TARGET ${PROJECT_NAME}_utest)
  if(ament_cmake_FOUND)
    target_include_directories(${PROJECT_NAME}_utest
      PUBLIC "../include")
    ament_target_dependencies(${PROJECT_NAME}_utest "console_bridge")
  else()
    target_include_directories(${PROJECT_NAME}_utest
      PUBLIC "../include" ${console_bridge_INCLUDE_DIRS})
    target_link_libraries(${PROJECT_NAME}_utest)
  endif()
  target_link_libraries(${PROJECT_NAME}_utest ${PROJECT_NAME})
  if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME}_utest pthread)
  endif()
  add_dependencies(${PROJECT_NAME}_utest
    ${PROJECT_NAME}_TestPlugins1
    ${PROJECT_NAME}_TestPlugins2
    ${PROJECT_NAME}_TestGlobalPlugins)
endif()

ament_add_gtest(${PROJECT_NAME}_unique_ptr_test unique_ptr_test.cpp
  APPEND_LIBRARY_DIRS "${append_library_dirs}"
)
if(TARGET ${PROJECT_NAME}_unique_ptr_test)
  if(ament_cmake_FOUND)
    target_include_directories(${PROJECT_NAME}_unique_ptr_test
      PUBLIC "../include")
    ament_target_dependencies(${PROJECT_NAME}_unique_ptr_test)
  else()
    target_include_directories(${PROJECT_NAME}_unique_ptr_test
      PUBLIC "../include")
    target_link_libraries(${PROJECT_NAME}_unique_ptr_test)
  endif()
  target_link_libraries(${PROJECT_NAME}_unique_ptr_test ${PROJECT_NAME})
  if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME}_unique_ptr_test pthread)
  endif()
  add_dependencies(${PROJECT_NAME}_unique_ptr_test
    ${PROJECT_NAME}_TestPlugins1
    ${PROJECT_NAME}_TestPlugins2)
endif()

add_subdirectory(fviz_case_study)

=== test/fviz_case_study/CMakeLists.txt ===
add_library(${PROJECT_NAME}_Test_Fviz EXCLUDE_FROM_ALL SHARED fviz.cpp)
if(WIN32)
  # Causes the visibility macros to use dllexport rather than dllimport
  # which is appropriate when building the dll but not consuming it.
  target_compile_definitions(${PROJECT_NAME}_Test_Fviz PRIVATE "FVIZ_BUILDING_DLL")
endif()

# This "fviz_main" is just for testing locally, for the test see "fviz_test" below.
add_executable(${PROJECT_NAME}_Test_Fviz_Main EXCLUDE_FROM_ALL fviz_main.cpp)
if(ament_cmake_FOUND)
  target_include_directories(${PROJECT_NAME}_Test_Fviz_Main
    PUBLIC "../include")
  ament_target_dependencies(${PROJECT_NAME}_Test_Fviz_Main "console_bridge")
else()
  target_include_directories(${PROJECT_NAME}_Test_Fviz_Main
    PUBLIC "../include" ${console_bridge_INCLUDE_DIRS})
endif()
target_link_libraries(${PROJECT_NAME}_Test_Fviz_Main
  ${PROJECT_NAME} ${PROJECT_NAME}_Test_Fviz)

add_library(${PROJECT_NAME}_Test_FvizDefaultPlugin
  EXCLUDE_FROM_ALL SHARED fviz_default_plugin.cpp)
target_include_directories(${PROJECT_NAME}_Test_FvizDefaultPlugin
  PUBLIC "../include" ${console_bridge_INCLUDE_DIRS})
target_link_libraries(${PROJECT_NAME}_Test_FvizDefaultPlugin
  ${PROJECT_NAME} ${PROJECT_NAME}_Test_Fviz)
class_loader_hide_library_symbols(${PROJECT_NAME}_Test_FvizDefaultPlugin)

if(WIN32)
  set(append_library_dirs "$<TARGET_FILE_DIR:${PROJECT_NAME}>;$<TARGET_FILE_DIR:${PROJECT_NAME}_TestPlugins1>")
else()
  set(append_library_dirs "${CMAKE_CURRENT_BINARY_DIR}")
endif()

ament_add_gtest(${PROJECT_NAME}_fviz_test fviz_test.cpp
  APPEND_LIBRARY_DIRS "${append_library_dirs}"
)
if(TARGET ${PROJECT_NAME}_fviz_test)
  if(ament_cmake_FOUND)
    target_include_directories(${PROJECT_NAME}_fviz_test
      PUBLIC "../include")
    ament_target_dependencies(${PROJECT_NAME}_fviz_test "console_bridge")
  else()
    target_include_directories(${PROJECT_NAME}_fviz_test
      PUBLIC "../include" ${console_bridge_INCLUDE_DIRS})
    target_link_libraries(${PROJECT_NAME}_fviz_test)
  endif()
  target_link_libraries(${PROJECT_NAME}_fviz_test
    ${PROJECT_NAME} ${PROJECT_NAME}_Test_Fviz)
  if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME}_fviz_test pthread)
  endif()
  add_dependencies(${PROJECT_NAME}_fviz_test
    ${PROJECT_NAME}_Test_FvizDefaultPlugin ${PROJECT_NAME}_Test_Fviz_Main)
endif()

=== debian/changelog ===
ros-class-loader (2.4.0-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Set field Upstream-Name in debian/copyright.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository-Browse.

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 15 Nov 2022 11:08:21 +0100

ros-class-loader (2.4.0-1) experimental; urgency=medium

  [ Jochen Sprickerhof ]
  * New upstream version 2.4.0
  * Move package description to source package

  [ Timo Röhling ]
  * Bump SONAME to 3d
  * Add myself to uploaders

 -- Timo Röhling <roehling@debian.org>  Sat, 05 Nov 2022 12:04:03 +0100

ros-class-loader (2.3.1-1) unstable; urgency=medium

  * New upstream version 2.3.1

 -- Jochen Sprickerhof <jspricke@debian.org>  Wed, 14 Sep 2022 16:57:15 +0200

=== debian/control ===
Source: ros-class-loader
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jochen Sprickerhof <jspricke@debian.org>,
           Leopold Palomo-Avellaneda <leo@alaxarxa.net>,
	   Timo Röhling <roehling@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 ament-cmake,
 ament-cmake-googletest <!nocheck>,
 ament-cmake-ros,
 ament-lint <!nocheck>,
 cmake,
 dh-ros,
 libconsole-bridge-dev,
 librcpputils-dev,
Standards-Version: 4.6.1
Section: libs
Rules-Requires-Root: no
Homepage: https://wiki.ros.org/class_loader
Vcs-Git: https://salsa.debian.org/science-team/ros-class-loader.git
Vcs-Browser: https://salsa.debian.org/science-team/ros-class-loader
Description: ROS class_loader library
 This package is part of Robot OS (ROS). The class_loader package is a
 ROS-independent package for loading plugins during runtime and the
 foundation of the higher level ROS "pluginlib" library.  class_loader
 utilizes the host operating system's runtime loader to open runtime
 libraries (e.g. .so/.dll files), introspect the library for exported
 plugin classes, and allows users to instantiate objects of said
 exported classes without the explicit declaration (i.e. header file)
 for those classes.

Package: libclass-loader-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libclass-loader3d (= ${binary:Version}),
 libconsole-bridge-dev,
 librcpputils-dev,
Breaks: pluginlib-dev (<< 5.2.0)
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 This package contains the development files for the library.

Package: libclass-loader3d
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package contains the library.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/ros/class_loader/tags \
    (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## ros-class-loader 2.6.0

=== debian/changelog ===
ros-class-loader (2.6.0-1) unstable; urgency=medium

  * New upstream version 2.6.0
  * Rediff patches
  * Bump policy version (no changes)

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 16 Jun 2023 19:49:04 +0200

## ros-class-loader 2.7.0

=== debian/changelog ===
ros-class-loader (2.7.0-1) unstable; urgency=medium

  * New upstream version 2.7.0
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Thu, 04 Jan 2024 23:53:33 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  dh-ros,
  libconsole-bridge-dev,
  librcpputils-dev,
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Section: libs
 Rules-Requires-Root: no
 Homepage: https://wiki.ros.org/class_loader

=== debian/rules ===
#!/usr/bin/make -f

export ROS_CONFIGURE_ARGS = -DCLASS_LOADER_SOVERSION=3d
export ROS_EXECUTE_AFTER_CONFIGURE=sed -i -e '1icmake_policy(SET CMP0057 NEW)' -e '$$aset(class_loader_FOUND_CATKIN_PROJECT TRUE)\nset(class_loader_INCLUDE_DIRS "/usr/include/class_loader;/usr/include/rcpputils;/usr/include/rcutils")\nset(class_loader_LIBRARIES "class_loader")' obj-$(DEB_HOST_GNU_TYPE)/class_loader/ament_cmake_core/class_loaderConfig.cmake

%:
	dh $@ --buildsystem=ros

## ros-class-loader 2.8.0

=== debian/changelog ===
ros-class-loader (2.8.0-1) unstable; urgency=medium

  * New upstream version 2.8.0
  * Bump Standards-Version to 4.7.0

 -- Timo Röhling <roehling@debian.org>  Mon, 29 Apr 2024 00:04:42 +0200

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  dh-ros,
  libconsole-bridge-dev,
  librcpputils-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: libs
 Rules-Requires-Root: no
 Homepage: https://wiki.ros.org/class_loader

## ros-class-loader 2.9.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,9 +2,10 @@
 
 project(class_loader)
 
-# Default to C++14
+# Default to C++17
 if(NOT CMAKE_CXX_STANDARD)
-  set(CMAKE_CXX_STANDARD 14)
+  set(CMAKE_CXX_STANDARD 17)
+  set(CMAKE_CXX_STANDARD_REQUIRED ON)
 endif()
 if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   add_compile_options(-Wall -Wextra -Wpedantic)
@@ -30,19 +31,18 @@
   ament_export_dependencies(rcpputils)
 endif()
 
-set(${PROJECT_NAME}_SRCS
+add_library(${PROJECT_NAME} ${explicit_library_type}
   src/class_loader.cpp
   src/class_loader_core.cpp
   src/meta_object.cpp
   src/multi_library_class_loader.cpp
 )
-add_library(${PROJECT_NAME} ${explicit_library_type} ${${PROJECT_NAME}_SRCS})
 target_include_directories(${PROJECT_NAME} PUBLIC
   "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
   "$<INSTALL_INTERFACE:include/${PROJECT_NAME}>")
 
 if(ament_cmake_FOUND)
-  target_link_libraries(${PROJECT_NAME}
+  target_link_libraries(${PROJECT_NAME} PUBLIC
     console_bridge::console_bridge
     rcpputils::rcpputils)
   ament_export_targets(${PROJECT_NAME})

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)

include("../cmake/class_loader_hide_library_symbols.cmake")

add_library(${PROJECT_NAME}_TestPlugins1 EXCLUDE_FROM_ALL SHARED plugins1.cpp)
target_link_libraries(${PROJECT_NAME}_TestPlugins1 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins1)

add_library(${PROJECT_NAME}_TestPlugins2 EXCLUDE_FROM_ALL SHARED plugins2.cpp)
target_link_libraries(${PROJECT_NAME}_TestPlugins2 ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestPlugins2)

# These plugins are loaded using dlopen() with RTLD_GLOBAL in utest and may cause side effects
# in other tests if they are used elsewhere.
add_library(${PROJECT_NAME}_TestGlobalPlugins EXCLUDE_FROM_ALL SHARED global_plugins.cpp)
target_link_libraries(${PROJECT_NAME}_TestGlobalPlugins ${PROJECT_NAME})
class_loader_hide_library_symbols(${PROJECT_NAME}_TestGlobalPlugins)

if(WIN32)
  set(append_library_dirs "$<TARGET_FILE_DIR:${PROJECT_NAME}>;$<TARGET_FILE_DIR:${PROJECT_NAME}_TestPlugins1>")
else()
  set(append_library_dirs "${CMAKE_CURRENT_BINARY_DIR}")
endif()

ament_add_gtest(${PROJECT_NAME}_utest utest.cpp
  APPEND_LIBRARY_DIRS "${append_library_dirs}"
)

if(TARGET ${PROJECT_NAME}_utest)
  target_link_libraries(${PROJECT_NAME}_utest ${PROJECT_NAME})
  if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME}_utest pthread)
  endif()
  add_dependencies(${PROJECT_NAME}_utest
    ${PROJECT_NAME}_TestPlugins1
    ${PROJECT_NAME}_TestPlugins2
    ${PROJECT_NAME}_TestGlobalPlugins)
endif()

ament_add_gtest(${PROJECT_NAME}_unique_ptr_test unique_ptr_test.cpp
  APPEND_LIBRARY_DIRS "${append_library_dirs}"
)
if(TARGET ${PROJECT_NAME}_unique_ptr_test)
  target_link_libraries(${PROJECT_NAME}_unique_ptr_test ${PROJECT_NAME})
  if(NOT WIN32)
    target_link_libraries(${PROJECT_NAME}_unique_ptr_test pthread)
  endif()
  add_dependencies(${PROJECT_NAME}_unique_ptr_test
    ${PROJECT_NAME}_TestPlugins1
    ${PROJECT_NAME}_TestPlugins2)
endif()

add_subdirectory(fviz_case_study)

=== debian/changelog ===
ros-class-loader (2.9.0-1) unstable; urgency=medium

  * New upstream version 2.9.0
  * Bump Standards-Version to 4.7.2
  * Wrap and sort Debian package files

 -- Timo Röhling <roehling@debian.org>  Wed, 20 Aug 2025 19:08:09 +0200
